#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

int main(int argc, char *argv[])
{
    printf("hello world (pid: %d)\n", getpid());
    int rc = fork();
    if (rc < 0) {
        // fork failed; exit
        fprintf(stderr, "fork failed.\n");
        exit(1);
    } else if (rc == 0) {
        // child (new process)
        printf("hello, I am the child (pid: %d)\n", getpid());
    } else {
        // parent goes down this path (original process)
        int status;
        int wc = wait(&status);
        printf("hello, I am the parent of %d (status: %d) (pid: %d)\n",
	       wc, WEXITSTATUS(status), getpid());
    }
    return 0;
}
